---
import { getCollection } from "astro:content";
import BaseLayout from "../layouts/BaseLayout.astro";
import BlogCard from "../components/BlogCard.astro";

export async function getStaticPaths() {
  const allPosts = await getCollection("posts");
  const uniqueTags = [...new Set(allPosts.map((post) => post.data.tags).flat())];

  return uniqueTags.map((tag) => {
    const filteredPosts = allPosts.filter((post) =>
      post.data.tags.includes(tag)
    );
    return {
      params: { tag },
      props: { posts: filteredPosts },
    };
  });
}

const { tag } = Astro.params;
const { posts } = Astro.props;
const allPosts = posts.sort(
    (a, b) => {
        return (a.data.pubDate > b.data.pubDate) ? -1 : 1
    }
);
---

<BaseLayout>
    <h2>
      <div class="inline-block bg-blue-200 rounded-full px-3 py-1 text-sm font-semibold text-blue-700 mb-2">
        <a class="" href={`/${tag}`}>
          {tag}
        </a>
      </div>
      のタグが付いた記事
    </h2>
    {
      allPosts.map((post) =>
        <BlogCard post = {post} />
      )
    }
</BaseLayout>
